/* *****************************************************************************
 * Copyright (c) IRISA Laboratory, 
 * Universite Bretagne Sud, France
 * <http://www-casa.irisa.fr/dodwan>
 *
 * This file is part of DoDWAN.
 * 
 * DoDWAN is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software 
 * Foundation, either version 3 of the License, or any later
 * version.
 * 
 * DoDWAN is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * DoDWAN.  If not, see <http://www.gnu.org/licenses/>.
 * ****************************************************************************/



package casa.dodwan.util;

public class BoundedHistory<TYPE> extends History<TYPE> {

	private long span_;

	// ------------------------------------------------------------
	public BoundedHistory(int size, long span) {
		super(size);
		span_ = span;
	}

	// ------------------------------------------------------------
	@Override
	public synchronized long lookupFirst(TYPE value) {

		purgeBefore(System.currentTimeMillis() - span_);
		return super.lookupFirst(value);
	}

	// ------------------------------------------------------------
	@Override
	public synchronized long lookupLast(TYPE value) {

		purgeBefore(System.currentTimeMillis() - span_);
		return super.lookupLast(value);
	}

	// //------------------------------------------------------------
	// public synchronized void put(TYPE value) {

	// purgeBefore(System.currentTimeMillis() - span_);
	// super.put(value);
	// }

	// ------------------------------------------------------------
	@Override
	public String toString() {

		purgeBefore(System.currentTimeMillis() - span_);
		return super.toString();
	}
}
