/* *****************************************************************************
 * Copyright (c) IRISA Laboratory, 
 * Universite Bretagne Sud, France
 * <http://www-casa.irisa.fr/dodwan>
 *
 * This file is part of DoDWAN.
 * 
 * DoDWAN is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software 
 * Foundation, either version 3 of the License, or any later
 * version.
 * 
 * DoDWAN is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * DoDWAN.  If not, see <http://www.gnu.org/licenses/>.
 * ****************************************************************************/



package casa.dodwan.util;

import java.util.HashSet;
import java.util.Set;

public class Listenable<LISTENER> {

	private Set<LISTENER> listeners_ = new HashSet<LISTENER>();

	public Verbosity verbosity = new Verbosity();

	// ------------------------------------------------------------
	public Listenable() {
	}

	// ------------------------------------------------------------
	public synchronized void addListener(LISTENER listener) {
		if (verbosity.isEnabled()) {
			System.out.println(this + "Listenable.addListener(" + listener
					+ ")");
		}
		listeners_.add(listener);
	}

	// ------------------------------------------------------------
	public synchronized Set<LISTENER> getListeners() {

		if (verbosity.isEnabled()) {
			System.out.println(this + "Listenable.getListeners()");
		}

		return listeners_;
	}

	// ------------------------------------------------------------
	public synchronized void removeListener(LISTENER listener) {
		if (verbosity.isEnabled()) {
			System.out.println(this + "Listenable.removeListener(" + listener
					+ ")");
		}
		listeners_.remove(listener);
	}

}
